#include <QCoreApplication>
#include <QTime>

#include <thread>
#include <vector>
#include <iostream>
#include <string>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    std::cout << "starting" << std::endl;

    auto doThing = [&a]() {
      auto time = QTime::fromMSecsSinceStartOfDay(1000000);
      auto string = time.toString("m:ss");
      auto stdString = string.toStdString();
      QMetaObject::invokeMethod(&a, [stdString](){
          std::cout << stdString << std::endl;
      });
    };

    std::vector<std::thread> threads;
    for (int i = 0; i < 5000; i++) {
        threads.emplace_back(std::thread(doThing));
    }

    std::cout << "started all threads" << std::endl;

    for (auto& thread : threads) {
        thread.join();
    }

    std::cout << "finishing" << std::endl;

    return a.exec();
}
